#include "mainwindow.h"
#include "ui_mainwindow.h"
#include <stdio.h>
#include <stdlib.h>
#include <qfile.h>
#include <QTextStream>

using namespace std;

MainWindow::MainWindow(QWidget *parent)
    : QMainWindow(parent), ui(new Ui::MainWindow)
{
    ui->setupUi(this);
}

MainWindow::~MainWindow()
{
    delete ui;
}

void MainWindow::on_pushButton_clicked()
{
    ui->plainTextEdit->clear();
    ui->plainTextEdit_2->clear();
    QString path = ui->lineEdit->text();
    QString command1 = "objdump -s ";
    QString command2 = "objdump -D ";
    QString objdump_S = command1.append(path).append(" > tmp");
    QString objdump_D = command2.append(path).append(" > tmp2");

    string first = objdump_S.toStdString();
    string second = objdump_D.toStdString();
    const char* final1 = first.c_str();
    const char* final2 = second.c_str();

    system(final2);
    ui->progressBar->setValue(30);
    system(final1);
    ui->progressBar->setValue(50);

    QFile file("tmp");
    if (!file.open(QIODevice::ReadOnly | QIODevice::Text))
         return;

     QTextStream in(&file);
     QString asm1 = in.readAll();
     ui->plainTextEdit->appendPlainText(asm1);
     ui->progressBar->setValue(80);
     /*while (!in.atEnd()) {
         QString line = in.readLine();
         ui->plainTextEdit->appendPlainText(line);
     }*/
     QFile file2("tmp2");
    if (!file2.open(QIODevice::ReadOnly | QIODevice::Text))
         return;

     QTextStream in2(&file2);
     QString asm2 = in2.readAll();
     ui->plainTextEdit_2->appendPlainText(asm2);
     ui->progressBar->setValue(100);
     /*while (!in2.atEnd()) {
         QString line2 = in2.readLine();
         ui->plainTextEdit_2->appendPlainText(line2);
     }*/
     system("rm tmp");
     system("rm tmp2");
     ui->label->clear();

}

void MainWindow::on_pushButton_pressed()
{
    ui->label->setText("WAIT...");
    ui->progressBar->setValue(10);
}

void MainWindow::on_find1_clicked()
{
    QString trova = ui->text_find->text();
    ui->plainTextEdit->find(trova);
}

void MainWindow::on_find2_clicked()
{
    QString trova = ui->text_find->text();
    ui->plainTextEdit->find(trova,QTextDocument::FindBackward);
}

void MainWindow::on_find3_clicked()
{
    QString trova = ui->text_find_2->text();
    ui->plainTextEdit_2->find(trova);
}

void MainWindow::on_find4_clicked()
{
    QString trova = ui->text_find_2->text();
    ui->plainTextEdit_2->find(trova,QTextDocument::FindBackward);
}
